<template>
  <nav role="navigation" class="fr-pagination" aria-label="Pagination">
    <ul class="fr-pagination__list">
      <li>
        <a
          class="fr-pagination__link fr-pagination__link--prev fr-pagination__link--lg-label"
          :aria-disabled="value === 1"
          aria-label="Passe aux résultats précédents"
          role="link"
          :href="value === 1 ? null : '#'"
          @click.prevent="changePage(value - 1)"
        >
          Précédent
        </a>
      </li>

      <li v-for="(page, index) in pageList" :key="`pagination-link--${index}`">
        <a
          v-if="page !== '...'"
          class="fr-pagination__link"
          :aria-current="page === value ? 'page' : null"
          :aria-label="'Passer à la page ' + page + ' des resultats'"
          href="#"
          @click.prevent="changePage(page)"
          >{{ page }}</a
        >
        <span v-if="page === '...'" class="fr-pagination__link fr-displayed-lg">
          ...
        </span>
      </li>

      <li>
        <a
          class="fr-pagination__link fr-pagination__link--next fr-pagination__link--lg-label"
          :aria-disabled="value === total"
          aria-label="Passer aux résultats suivants"
          :href="value === total ? null : '#'"
          role="link"
          @click.prevent="changePage(value + 1)"
        >
          Suivant
        </a>
      </li>
    </ul>
  </nav>
</template>

<script>
export default {
  name: 'FrPagination',

  props: {
    value: {
      type: Number,
      required: true,
    },
    total: {
      type: Number,
      required: true,
    },
  },

  computed: {
    pageList() {
      if (this.total < 7) {
        return Array.from({ length: this.total || 1 }, (_, index) => index + 1);
      }

      if (this.value < 3) {
        return [1, 2, 3, '...', this.total];
      }

      if (this.value === 3) {
        return [1, 2, 3, 4, '...', this.total];
      }

      if (this.value === 8) {
        return [
          1,
          '...',
          this.total - 3,
          this.total - 2,
          this.total - 1,
          this.total,
        ];
      }

      if (this.total - this.value < 2) {
        return [1, '...', this.total - 2, this.total - 1, this.total];
      }

      return [
        1,
        '...',
        this.value - 1,
        this.value,
        this.value + 1,
        '...',
        this.total,
      ];
    },
  },

  methods: {
    changePage(pageNumber) {
      if (
        pageNumber > 0 &&
        pageNumber <= this.total &&
        pageNumber !== this.value
      ) {
        this.$emit('input', pageNumber);
      }
    },
  },
};
</script>
